#ifndef EFL_UI_MODEL_FACTORY_CONNECT_EO_HH
#define EFL_UI_MODEL_FACTORY_CONNECT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_factory.eo.h"
#include "efl_ui_model_factory_connect.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_ui_factory.eo.hh"
namespace efl { namespace ui { namespace model { namespace factory { 
struct Connect;
} } } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::model::factory::Connect> : ::std::true_type {}; } }
namespace efl { namespace ui { namespace model { namespace factory { 
struct Connect;
} } } } 
namespace efl { namespace ui { 
struct Factory;
} } 

namespace eo_cxx {
namespace efl { namespace ui { namespace model { namespace factory { 
struct Connect {
   ::efl::eolian::return_traits<void>::type connect( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::in_traits< ::efl::ui::Factory>::type factory) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_MODEL_FACTORY_CONNECT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::model::factory::Connect() const;
   operator ::efl::ui::model::factory::Connect&();
   operator ::efl::ui::model::factory::Connect const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Connect> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Connect const > operator&() const { return {this}; }
   /// @endcond
};
} } } } 
}
namespace efl { namespace ui { namespace model { namespace factory { 
struct Connect : ::efl::eo::concrete
{
   explicit Connect( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Connect(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Connect(Connect const& other) = default;
   Connect(Connect&& other) = default;
   Connect& operator=(Connect const& other) = default;
   Connect& operator=(Connect&& other) = default;
   Connect()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Connect( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Connect(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type connect( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::in_traits< ::efl::ui::Factory>::type factory) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_MODEL_FACTORY_CONNECT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Connect> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Connect const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Connect) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Connect>::value, "");
} } } } 
#endif
